<?php
function smarty_block_MTLinkingEntries($args, $content, &$ctx, &$repeat) {
	require_once('rightfields_lib.php');
	$local = array('entry', 'current_timestamp', 'current_timestamp_end',
		'modification_timestamp', 'blog', 'blog_id', 'rf_linking_entries',
		'rf_le_counter', 'linking_entry');
	if (!isset($content)) {
		$ctx->localize($local);
		$entry = $ctx->stash('entry');
		if (!$entry) return '';
		if (!$args['field']) return '';
		$blog_ids_str = $args['blog_ids'] ? $args['blog_ids'] : $args['blog_id'];
		$entries = array();
		$mt_fields = mt_fields();
		if (array_search($args['field'], $mt_fields)) {
			$sql = <<<SQL
SELECT entry_id FROM mt_entry
WHERE entry_{$args['field']} = {$entry['entry_id']}
SQL;
			if ($blog_ids_str) {
				$sql .= "AND entry_blog_id IN ($blog_ids_str)";
			}
			$rows = $ctx->mt->db->get_results($sql, ARRAY_N);
			if (!$rows) return '';
			foreach ($rows as $row) {
				$entry = $ctx->mt->db->fetch_entry($row[0]);
				array_push($entries, $entry);
			}
		} else {
			if ($blog_ids_str) {
				$blog_ids = explode(',', $blog_ids_str);
			}
			$cfg = blog_data($ctx->mt->db, 'extra', $blog_ids ? $blog_ids[0] : -1);
			if ($cfg->{'datasource'} == '_pseudo') return '';
			$sql = <<<SQL
SELECT {$cfg['datasource']}_id FROM mt_{$cfg['datasource']}
WHERE {$cfg['datasource']}_{$args['field']} = {$entry['entry_id']}
SQL;
			$entries = array();
			$ef_rows = $ctx->mt->db->get_results($sql, ARRAY_N);
			if (!$ef_rows) return '';
			foreach ($ef_rows as $row) {
				$linking_entry = $ctx->mt->db->fetch_entry($row[0]);
				if ($blog_ids && !in_array($linking_entry['entry_blog_id'], $blog_ids)) continue;
				if ($linking_entry['entry_status'] != 2) continue;
				array_push($entries, $linking_entry);
			}
		}
		if ($args['sort_by'] == 'title') {
			if ($args['sort_order'] == 'descend') {
				usort($entries, 'sort_entries_title_desc');
			} else {
				usort($entries, 'sort_entries_title_asc');
			}
		} else {
			if ($args['sort_order'] == 'ascend') {
				usort($entries, 'sort_entries_date_asc');
			} else {
				usort($entries, 'sort_entries_date_desc');
			}
		}
		$ctx->stash('rf_linking_entries', $entries);
		$counter = 0;
	} else {
		$counter = $ctx->stash('rf_le_counter');
		$entries = $ctx->stash('rf_linking_entries');
	}
	if (!$entries) return '';
	if ($counter < count($entries)) {
		$linking_entry = $entries[$counter];
		$ctx->stash('entry', $linking_entry);
		$ctx->stash('current_timestamp', $linking_entry['entry_created_on']);
		$ctx->stash('current_timestamp_end', null);
		$ctx->stash('modification_timestamp', 
			$linking_entry['entry_modified_on']);
		$ctx->stash('rf_le_counter', $counter + 1);
		$ctx->stash('blog_id', $linking_entry['entry_blog_id']);
		$ctx->stash('blog', $ctx->mt->db->fetch_blog($linking_entry['entry_blog_id']));
		$repeat = true;
	}
	if (!$repeat) $ctx->restore($local);
	return $content;
}
?>
